#<profile4xi profile = "20" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "autoproxy4xi.py">
#<abstract4xi abstract = "Provides function AutoProxy4Xi" />
#<refer4xi reference = "managers.py" />
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
#<note4xi note = "function name starts with capital" />
# -------------------------------------------------------------------------------------------------

#
# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = ['AutoProxy4Xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass    
try:                 # most-common ones
    import weakref
    import array
    from traceback import format_exc         
except:
    pass
try:                 # rare ones
    import queue         
except:
    pass 
     
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.managers import AutoProxy
except:
    print("autoproxy4xi.py *** failed in from multiprocessing.managers import AutoProxy ***")
#"
#/>
 
# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from current_process4xi import get_authkey_current_process4xi
from dispatch4xi import dispatch4xi
from listener_client4xi import listener_client4xi
from makeproxytype4xi import MakeProxyType4Xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>




# -------------------------------------------------------------------------------------------------
#<function4xi function = "AutoProxy4Xi" usage = "
#
#     managers.py
#         if proxytype is None:
#             proxytype = AutoProxy
#     basemanager4xi.py:
#         proxytype = AutoProxy4Xi
#     baseproxy4xi.py:
#         (AutoProxy4Xi, self._token, self._serializer, kwds))
#     syncmanager4xi.py:
#         proxytype = AutoProxy4Xi
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
#"
#>
def AutoProxy4Xi(token, serializer, manager=None, authkey=None, exposed=None, incref=True):
    '''
    Return an auto-proxy for token
    '''
    # ---------------------------------------------------------------------------------------------    
    # (Step 1/7)
    # --------------------------------------------------------------------------------------------- 
    class2print = 'AutoProxy4Xi'
    method2print = 'AutoProxy4Xi'
    
    message2print = "{(Step 1/7a) started" + "; AutoProxy4Xi-started: " + str(AutoProxy4Xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
  
    message2print = "{(Step 1/7b) passed; token-passed-to-AutoProxy4Xi: " + str(token) + "}"
    print4xi(class2print, method2print, message2print)    

    message2print = "{(Step 1/7c) passed; serializer-passed-to-AutoProxy4Xi: " + str(serializer) + "}"
    print4xi(class2print, method2print, message2print) 
    
    message2print = "{(Step 1/7d) passed; manager-passed-to-AutoProxy4Xi: " + str(manager) + "}"
    print4xi(class2print, method2print, message2print) 
    
    message2print = "{(Step 1/7e) passed; authkey-passed-to-AutoProxy4Xi: " + str(authkey) + "}"
    print4xi(class2print, method2print, message2print)
    
    message2print = "{(Step 1/7f) passed; exposed-passed-to-AutoProxy4Xi: " + str(exposed) + "}"
    print4xi(class2print, method2print, message2print) 
    
    message2print = "{(Step 1/7g) passed; incref-passed-to-AutoProxy4Xi: " + str(incref) + "}"
    print4xi(class2print, method2print, message2print)  
    
    # ---------------------------------------------------------------------------------------------    
    # DRAGONIZED AUTHORIZATION KEY PROCESSING
    # --------------------------------------------------------------------------------------------- 
    
    if authkey is None and manager is not None:
    
        authkey = manager._authkey
        
        message2print = "{(Step 1/7f) set" + "; authkey-set-by-AutoProxy4Xi to: " + str(authkey)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
   
    if authkey is None:
    
        authkey = get_authkey_current_process4xi() #dragonized
        
        message2print = "{(Step 1/7g) set" + "; authkey-set-by-AutoProxy4Xi to: " + str(authkey)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
              
       
    
    
    message2print = "{(Step 1/7f) passed; exposed-passed-to-AutoProxy4Xi: " + str(exposed) + "}"
    print4xi(class2print, method2print, message2print) 
    
    message2print = "{(Step 1/7g) passed; incref-passed-to-AutoProxy4Xi: " + str(incref) + "}"
    print4xi(class2print, method2print, message2print)         
                           
    # ---------------------------------------------------------------------------------------------    
    # (Step 2/7)
    # ---------------------------------------------------------------------------------------------         
    ack2serializer = False
    nack2serializer = True
               
    try:   
        message2print = "{(Step 2/7a) passing" + "; serializer-passing-to-listener-client4xi-by-AutoProxy4Xi: " + str([serializer][1]) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        
        ack2serializer = True
        
        message2print = "{(Step 2/7b) set" + "; ack2serializer-set-by-AutoProxy4Xi to: " + str(ack2serializer)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)               
                 
    except:
        message2print = "{(Step 2/7c) yielded" + "; nack2serializer-yielded-by-AutoProxy4Xi: " + str(nack2serializer)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
            

    _Client = listener_client4xi[serializer][1]
    
       
    message2print = "{(Step 2/7b) created" + "; Client-of-autoproxy4xi-created-by-AutoProxy4Xi: " + str(_Client) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         
    
   
    # ---------------------------------------------------------------------------------------------    
    # (Step 3/7)
    # ---------------------------------------------------------------------------------------------     
    
    if exposed is None:
        if token.address is None:
            message2print = "{(Step 3/7a) warning" + "; token-address-warning-by-AutoProxy4Xi: " + " ** " + str(token.address)  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                     
                
               
        message2print = "{(Step 3/7b) passing" + "; token-address-passing-to-Client-of-autoproxy4xi-by-AutoProxy4Xi: " + str(token.address) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        
        message2print = "{(Step 3/7c) passing" + "; authkey-passing-to-Client-of-autoproxy4xi-by-AutoProxy4Xi: " + str(authkey) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
      
        conn2xi = _Client(token.address, authkey)
                
        message2print = "{(Step 3/7d) set" + "; connection-set-by-AutoProxy4Xi to: " + str(conn2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
           
  

        try:
            message2print = "{(Step 3/7e) passing" + "; connection-passing-to-dispatch4xi-by-AutoProxy4Xi: " + str(conn2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
          
            message2print = "{(Step 3/7f) passing" + "; token-passing-to-dispatch4xi-by-AutoProxy4Xi: " + str(token) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)           
            
            exposed = dispatch4xi(conn2xi, None, 'get_methods', (token,))
            
            message2print = "{(Step 3/7g) set" + "; exposed-by-AutoProxy4Xi: " + str(exposed)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)        
   
        finally:
            conn2xi.close()
        
            message2print = "{(Step 3/7h) performed" + "; connection-close-performed-by-AutoProxy4Xi: " + str(conn2xi.close) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
                  
               

        
        
    # ---------------------------------------------------------------------------------------------    
    # (Step 5/7)
    # --------------------------------------------------------------------------------------------- 
    
    ProxyType2xi = MakeProxyType4Xi('AutoProxy4Xi[%s]' % token.typeid, exposed)
     
    message2print = "{(Step 5/7) created" + "; ProxyType2xi-of-autoproxy4xi-created-by-AutoProxy4Xi: " + str(ProxyType2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         
             
       
    
    # ---------------------------------------------------------------------------------------------    
    # (Step 6/7)
    # --------------------------------------------------------------------------------------------- 
   
    message2print = "{(Step 6/7a) passing; token-passing-to-proxytype2xi-by-AutoProxy4Xi: " + str(token) + "}"
    print4xi(class2print, method2print, message2print)    
    
    message2print = "{(Step 6/7b) passing; serializer-passing-to-ProxyType2xi-of-autoproxy4xi-by-AutoProxy4Xi: " + str(serializer) + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{(Step 6/7c) passing; manager-passing-to-ProxyType2xi-of-autoproxy4xi-by-AutoProxy4Xi: " + str(manager) + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{(Step 6/7d) passing; authkey-passing-to-ProxyType2xi-of-autoproxy4xi-by-AutoProxy4Xi: " + str(authkey) + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{(Step 6/7e) passing; incref-passing-to-ProxyType2xi-of-autoproxy4xi-by-AutoProxy4Xi: " + str(incref) + "}"
    print4xi(class2print, method2print, message2print)  

    
    proxy2xi = ProxyType2xi(token, serializer, manager, authkey, incref)
    
    message2print = "{(Step 6/7f) set" + "; proxy2xi-set-by-AutoProxy4Xi to: " + str(proxy2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
            
    
    
    proxy2xi._isauto = True

    message2print = "{(Step 6/7g) set" + "; proxy2xi-isauto-set-by-AutoProxy4Xi to: " + str(proxy2xi._isauto)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
            
    # ---------------------------------------------------------------------------------------------    
    # (Step 7/7)
    # --------------------------------------------------------------------------------------------- 
       
    message2print = "{(Step 7/7) returning" + "; proxy2xi-returning-by-AutoProxy4Xi: " + str(proxy2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   

        
    return proxy2xi  

#</function4xi>

#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

    
    


#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of autoproxy4xi.py                            
# ------------------------------------------------------------------------------------------------- 
#"
#/>


